
_uv2_get_8bit:

;uv2_click_example.c,3 :: 		uint8_t uv2_get_8bit(uint8_t reg)
;uv2_click_example.c,5 :: 		uint8_t temp = 0;
	PUSH       R2
;uv2_click_example.c,6 :: 		TWI_Start();
	CALL       _TWI_Start+0
;uv2_click_example.c,7 :: 		TWI_Write(0x20);
	PUSH       R2
	LDI        R27, 32
	MOV        R2, R27
	CALL       _TWI_Write+0
	POP        R2
;uv2_click_example.c,8 :: 		TWI_Write(reg);
	CALL       _TWI_Write+0
;uv2_click_example.c,9 :: 		TWI_Stop();
	CALL       _TWI_Stop+0
;uv2_click_example.c,10 :: 		TWI_Start();
	CALL       _TWI_Start+0
;uv2_click_example.c,11 :: 		TWI_WRite(0x21);
	LDI        R27, 33
	MOV        R2, R27
	CALL       _TWI_Write+0
;uv2_click_example.c,12 :: 		temp = TWI_Read(0);
	CLR        R2
	CALL       _TWI_Read+0
;uv2_click_example.c,13 :: 		TWI_Stop();
	CALL       _TWI_Stop+0
;uv2_click_example.c,14 :: 		}
L_end_uv2_get_8bit:
	POP        R2
	RET
; end of _uv2_get_8bit

_uv2_get_16bit:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 4
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;uv2_click_example.c,16 :: 		uint16_t uv2_get_16bit (uint8_t reg)
;uv2_click_example.c,18 :: 		uint8_t temp[2] = {0};
	PUSH       R2
	LDI        R27, 0
	STD        Y+0, R27
	LDI        R27, 0
	STD        Y+1, R27
;uv2_click_example.c,19 :: 		uint16_t retval = 0;
;uv2_click_example.c,21 :: 		TWI_Start();
	CALL       _TWI_Start+0
;uv2_click_example.c,22 :: 		TWI_Write(0x20);
	PUSH       R2
	LDI        R27, 32
	MOV        R2, R27
	CALL       _TWI_Write+0
	POP        R2
;uv2_click_example.c,23 :: 		TWI_Write(reg);
	CALL       _TWI_Write+0
;uv2_click_example.c,24 :: 		TWI_Stop();
	CALL       _TWI_Stop+0
;uv2_click_example.c,25 :: 		TWI_Start();
	CALL       _TWI_Start+0
;uv2_click_example.c,26 :: 		TWI_WRite(0x21);
	LDI        R27, 33
	MOV        R2, R27
	CALL       _TWI_Write+0
;uv2_click_example.c,27 :: 		temp[0] = TWI_Read(0);
	MOVW       R16, R28
	STD        Y+2, R16
	STD        Y+3, R17
	CLR        R2
	CALL       _TWI_Read+0
	LDD        R17, Y+2
	LDD        R18, Y+3
	MOV        R30, R17
	MOV        R31, R18
	ST         Z, R16
;uv2_click_example.c,28 :: 		temp[1] = TWI_Read(0);
	MOVW       R16, R28
	SUBI       R16, 255
	SBCI       R17, 255
	STD        Y+2, R16
	STD        Y+3, R17
	CLR        R2
	CALL       _TWI_Read+0
	LDD        R17, Y+2
	LDD        R18, Y+3
	MOV        R30, R17
	MOV        R31, R18
	ST         Z, R16
;uv2_click_example.c,30 :: 		retval = (uint16_t) temp[0];
	MOVW       R20, R28
	MOVW       R30, R20
	LD         R16, Z
	MOV        R18, R16
	LDI        R19, 0
;uv2_click_example.c,31 :: 		retval |= ((uint16_t) temp[1]) << 8;
	MOVW       R30, R20
	ADIW       R30, 1
	LD         R16, Z
	LDI        R17, 0
	MOV        R17, R16
	CLR        R16
	OR         R16, R18
	OR         R17, R19
; retval start address is: 18 (R18)
	MOVW       R18, R16
;uv2_click_example.c,32 :: 		TWI_Stop();
	CALL       _TWI_Stop+0
;uv2_click_example.c,34 :: 		return retval;
	MOVW       R16, R18
; retval end address is: 18 (R18)
;uv2_click_example.c,35 :: 		}
;uv2_click_example.c,34 :: 		return retval;
;uv2_click_example.c,35 :: 		}
L_end_uv2_get_16bit:
	POP        R2
	ADIW       R28, 3
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _uv2_get_16bit

_get_uv_index:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SUBI       R28, 88
	SBCI       R29, 0
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;uv2_click_example.c,37 :: 		float get_uv_index()
;uv2_click_example.c,39 :: 		float UVA = 0.0;
	PUSH       R2
;uv2_click_example.c,40 :: 		float UVB = 0.0;
;uv2_click_example.c,41 :: 		float UVcomp1 = 0.0;
;uv2_click_example.c,42 :: 		float UVcomp2 = 0.0;
;uv2_click_example.c,43 :: 		float UVD = 0.0;
;uv2_click_example.c,44 :: 		float UVAcomp = 0.0;
;uv2_click_example.c,45 :: 		float UVBcomp = 0.0;
;uv2_click_example.c,46 :: 		float UVI = 0.0;
;uv2_click_example.c,47 :: 		float UVAresp = 0.0011;
	LDI        R30, #lo_addr(?ICSget_uv_index_UVAresp_L0+0)
	LDI        R31, hi_addr(?ICSget_uv_index_UVAresp_L0+0)
	MOVW       R26, R28
	ADIW       R26, 24
	LDI        R24, 24
	LDI        R25, 0
	CALL       ___CC2DW+0
;uv2_click_example.c,48 :: 		float UVBresp = 0.00125;
;uv2_click_example.c,50 :: 		float a = 3.33;
;uv2_click_example.c,51 :: 		float b = 2.5;
;uv2_click_example.c,52 :: 		float c = 3.66;
;uv2_click_example.c,53 :: 		float d = 2.75;
;uv2_click_example.c,55 :: 		UVA = (float) uv2_get_16bit(0x07);
	LDI        R27, 7
	MOV        R2, R27
	CALL       _uv2_get_16bit+0
	LDI        R18, 0
	MOV        R19, R18
	CALL       _float_ulong2fp+0
	STD        Y+0, R16
	STD        Y+1, R17
	STD        Y+2, R18
	STD        Y+3, R19
;uv2_click_example.c,56 :: 		UVD = (float) uv2_get_16bit(0x08);
	LDI        R27, 8
	MOV        R2, R27
	CALL       _uv2_get_16bit+0
	LDI        R18, 0
	MOV        R19, R18
	CALL       _float_ulong2fp+0
	STD        Y+16, R16
	STD        Y+17, R17
	STD        Y+18, R18
	STD        Y+19, R19
;uv2_click_example.c,57 :: 		UVB = (float) uv2_get_16bit(0x09);
	LDI        R27, 9
	MOV        R2, R27
	CALL       _uv2_get_16bit+0
	LDI        R18, 0
	MOV        R19, R18
	CALL       _float_ulong2fp+0
	STD        Y+4, R16
	STD        Y+5, R17
	STD        Y+6, R18
	STD        Y+7, R19
;uv2_click_example.c,58 :: 		UVcomp1 = (float) uv2_get_16bit(0x0A);
	LDI        R27, 10
	MOV        R2, R27
	CALL       _uv2_get_16bit+0
	LDI        R18, 0
	MOV        R19, R18
	CALL       _float_ulong2fp+0
	STD        Y+8, R16
	STD        Y+9, R17
	STD        Y+10, R18
	STD        Y+11, R19
;uv2_click_example.c,59 :: 		UVcomp2 = (float) uv2_get_16bit(0x0B);
	LDI        R27, 11
	MOV        R2, R27
	CALL       _uv2_get_16bit+0
	LDI        R18, 0
	MOV        R19, R18
	CALL       _float_ulong2fp+0
	STD        Y+12, R16
	STD        Y+13, R17
	STD        Y+14, R18
	STD        Y+15, R19
;uv2_click_example.c,61 :: 		UVAcomp = ( UVA - UVD ) - a * ( UVcomp1 - UVD ) - b * ( UVcomp2 - UVD );
	LDD        R20, Y+16
	LDD        R21, Y+17
	LDD        R22, Y+18
	LDD        R23, Y+19
	LDD        R16, Y+0
	LDD        R17, Y+1
	LDD        R18, Y+2
	LDD        R19, Y+3
	CALL       _float_fpsub1+0
	MOVW       R30, R28
	SUBI       R30, 180
	SBCI       R31, 255
	ST         Z+, R16
	ST         Z+, R17
	ST         Z+, R18
	ST         Z+, R19
	LDD        R20, Y+16
	LDD        R21, Y+17
	LDD        R22, Y+18
	LDD        R23, Y+19
	LDD        R16, Y+8
	LDD        R17, Y+9
	LDD        R18, Y+10
	LDD        R19, Y+11
	CALL       _float_fpsub1+0
	MOVW       R30, R28
	SUBI       R30, 172
	SBCI       R31, 255
	ST         Z+, R16
	ST         Z+, R17
	ST         Z+, R18
	ST         Z+, R19
	LDD        R20, Y+32
	LDD        R21, Y+33
	LDD        R22, Y+34
	LDD        R23, Y+35
	CALL       _float_fpmul1+0
	STD        Y+48, R16
	STD        Y+49, R17
	STD        Y+50, R18
	STD        Y+51, R19
	MOVW       R30, R28
	SUBI       R30, 180
	SBCI       R31, 255
	LD         R16, Z+
	LD         R17, Z+
	LD         R18, Z+
	LD         R19, Z+
	LDD        R20, Y+48
	LDD        R21, Y+49
	LDD        R22, Y+50
	LDD        R23, Y+51
	CALL       _float_fpsub1+0
	MOVW       R30, R28
	SUBI       R30, 180
	SBCI       R31, 255
	ST         Z+, R16
	ST         Z+, R17
	ST         Z+, R18
	ST         Z+, R19
	LDD        R20, Y+16
	LDD        R21, Y+17
	LDD        R22, Y+18
	LDD        R23, Y+19
	LDD        R16, Y+12
	LDD        R17, Y+13
	LDD        R18, Y+14
	LDD        R19, Y+15
	CALL       _float_fpsub1+0
	MOVW       R30, R28
	SUBI       R30, 176
	SBCI       R31, 255
	ST         Z+, R16
	ST         Z+, R17
	ST         Z+, R18
	ST         Z+, R19
	LDD        R20, Y+36
	LDD        R21, Y+37
	LDD        R22, Y+38
	LDD        R23, Y+39
	CALL       _float_fpmul1+0
	STD        Y+48, R16
	STD        Y+49, R17
	STD        Y+50, R18
	STD        Y+51, R19
	MOVW       R30, R28
	SUBI       R30, 180
	SBCI       R31, 255
	LD         R16, Z+
	LD         R17, Z+
	LD         R18, Z+
	LD         R19, Z+
	LDD        R20, Y+48
	LDD        R21, Y+49
	LDD        R22, Y+50
	LDD        R23, Y+51
	CALL       _float_fpsub1+0
	STD        Y+20, R16
	STD        Y+21, R17
	STD        Y+22, R18
	STD        Y+23, R19
;uv2_click_example.c,62 :: 		UVBcomp = ( UVB - UVD ) - c * ( UVcomp1 - UVD ) - d * ( UVcomp2 - UVD );
	LDD        R20, Y+16
	LDD        R21, Y+17
	LDD        R22, Y+18
	LDD        R23, Y+19
	LDD        R16, Y+4
	LDD        R17, Y+5
	LDD        R18, Y+6
	LDD        R19, Y+7
	CALL       _float_fpsub1+0
	MOVW       R30, R28
	SUBI       R30, 172
	SBCI       R31, 255
	LD         R20, Z+
	LD         R21, Z+
	LD         R22, Z+
	LD         R23, Z+
	MOVW       R30, R28
	SUBI       R30, 180
	SBCI       R31, 255
	ST         Z+, R16
	ST         Z+, R17
	ST         Z+, R18
	ST         Z+, R19
	LDD        R16, Y+40
	LDD        R17, Y+41
	LDD        R18, Y+42
	LDD        R19, Y+43
	CALL       _float_fpmul1+0
	STD        Y+48, R16
	STD        Y+49, R17
	STD        Y+50, R18
	STD        Y+51, R19
	MOVW       R30, R28
	SUBI       R30, 180
	SBCI       R31, 255
	LD         R16, Z+
	LD         R17, Z+
	LD         R18, Z+
	LD         R19, Z+
	LDD        R20, Y+48
	LDD        R21, Y+49
	LDD        R22, Y+50
	LDD        R23, Y+51
	CALL       _float_fpsub1+0
	MOVW       R30, R28
	SUBI       R30, 176
	SBCI       R31, 255
	LD         R20, Z+
	LD         R21, Z+
	LD         R22, Z+
	LD         R23, Z+
	MOVW       R30, R28
	SUBI       R30, 180
	SBCI       R31, 255
	ST         Z+, R16
	ST         Z+, R17
	ST         Z+, R18
	ST         Z+, R19
	LDD        R16, Y+44
	LDD        R17, Y+45
	LDD        R18, Y+46
	LDD        R19, Y+47
	CALL       _float_fpmul1+0
	STD        Y+48, R16
	STD        Y+49, R17
	STD        Y+50, R18
	STD        Y+51, R19
	MOVW       R30, R28
	SUBI       R30, 180
	SBCI       R31, 255
	LD         R16, Z+
	LD         R17, Z+
	LD         R18, Z+
	LD         R19, Z+
	LDD        R20, Y+48
	LDD        R21, Y+49
	LDD        R22, Y+50
	LDD        R23, Y+51
	CALL       _float_fpsub1+0
;uv2_click_example.c,64 :: 		UVI = ( (UVBcomp * UVBresp) + (UVAcomp * UVAresp) ) / 2;
	LDD        R20, Y+28
	LDD        R21, Y+29
	LDD        R22, Y+30
	LDD        R23, Y+31
	CALL       _float_fpmul1+0
	MOVW       R30, R28
	SUBI       R30, 180
	SBCI       R31, 255
	ST         Z+, R16
	ST         Z+, R17
	ST         Z+, R18
	ST         Z+, R19
	LDD        R16, Y+20
	LDD        R17, Y+21
	LDD        R18, Y+22
	LDD        R19, Y+23
	LDD        R20, Y+24
	LDD        R21, Y+25
	LDD        R22, Y+26
	LDD        R23, Y+27
	CALL       _float_fpmul1+0
	MOVW       R30, R28
	SUBI       R30, 180
	SBCI       R31, 255
	LD         R20, Z+
	LD         R21, Z+
	LD         R22, Z+
	LD         R23, Z+
	CALL       _float_fpadd1+0
	LDI        R20, 0
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 64
	CALL       _float_fpdiv1+0
;uv2_click_example.c,66 :: 		return UVI;
;uv2_click_example.c,67 :: 		}
;uv2_click_example.c,66 :: 		return UVI;
;uv2_click_example.c,67 :: 		}
L_end_get_uv_index:
	POP        R2
	SUBI       R28, 169
	SBCI       R29, 255
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _get_uv_index

_InitMCU:

;uv2_click_example.c,69 :: 		void InitMCU()
;uv2_click_example.c,71 :: 		TWI_Init( 100000 );
	IN         R27, TWPS0_bit+0
	CBR        R27, BitMask(TWPS0_bit+0)
	OUT        TWPS0_bit+0, R27
	IN         R27, TWPS1_bit+0
	CBR        R27, BitMask(TWPS1_bit+0)
	OUT        TWPS1_bit+0, R27
	LDI        R27, 32
	OUT        TWBR+0, R27
	CALL       _TWI_Init+0
;uv2_click_example.c,72 :: 		Delay_ms(100);
	LDI        R18, 5
	LDI        R17, 15
	LDI        R16, 242
L_InitMCU0:
	DEC        R16
	BRNE       L_InitMCU0
	DEC        R17
	BRNE       L_InitMCU0
	DEC        R18
	BRNE       L_InitMCU0
;uv2_click_example.c,73 :: 		}
L_end_InitMCU:
	RET
; end of _InitMCU

_main:
	LDI        R27, 255
	OUT        SPL+0, R27
	LDI        R27, 0
	OUT        SPL+1, R27
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 26
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;uv2_click_example.c,74 :: 		void main()
;uv2_click_example.c,76 :: 		float uvindex = 0.0;
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	PUSH       R6
	PUSH       R7
;uv2_click_example.c,78 :: 		uint16_t read16 = 0;
;uv2_click_example.c,82 :: 		Uart1_Init(9600);
	LDI        R27, 51
	OUT        UBRRL+0, R27
	LDI        R27, 0
	OUT        UBRRH+0, R27
	CALL       _UART1_Init+0
;uv2_click_example.c,83 :: 		Uart1_Write_Text("Uart initialized \r\n");
	LDI        R27, #lo_addr(?lstr1_uv2_click_example+0)
	MOV        R2, R27
	LDI        R27, hi_addr(?lstr1_uv2_click_example+0)
	MOV        R3, R27
	CALL       _UART1_Write_Text+0
;uv2_click_example.c,86 :: 		setup[0] = 0x00;
	MOVW       R30, R28
	LDI        R27, 0
	ST         Z+, R27
	ST         Z+, R27
;uv2_click_example.c,87 :: 		setup[1] = 0x00;
	MOVW       R16, R28
	MOVW       R30, R16
	ADIW       R30, 2
	LDI        R27, 0
	ST         Z+, R27
	ST         Z+, R27
;uv2_click_example.c,88 :: 		setup[2] = 0x00;
	MOVW       R16, R28
	MOVW       R30, R16
	ADIW       R30, 4
	LDI        R27, 0
	ST         Z+, R27
	ST         Z+, R27
;uv2_click_example.c,90 :: 		InitMCU();            // Initialize MCU
	CALL       _InitMCU+0
;uv2_click_example.c,92 :: 		TWI_Start();
	CALL       _TWI_Start+0
;uv2_click_example.c,93 :: 		TWI_Write(0x20);
	LDI        R27, 32
	MOV        R2, R27
	CALL       _TWI_Write+0
;uv2_click_example.c,94 :: 		TWI_Write(0x00);
	CLR        R2
	CALL       _TWI_Write+0
;uv2_click_example.c,95 :: 		TWI_Write(0x00);
	CLR        R2
	CALL       _TWI_Write+0
;uv2_click_example.c,96 :: 		TWI_Write(0x00);
	CLR        R2
	CALL       _TWI_Write+0
;uv2_click_example.c,97 :: 		TWI_STop();
	CALL       _TWI_Stop+0
;uv2_click_example.c,99 :: 		while(1)
L_main2:
;uv2_click_example.c,101 :: 		uvindex = get_uv_index();
	CALL       _get_uv_index+0
;uv2_click_example.c,102 :: 		floattostr(uvindex, txt);
	MOVW       R20, R28
	SUBI       R20, 250
	SBCI       R21, 255
	MOVW       R6, R20
	MOVW       R2, R16
	MOVW       R4, R18
	CALL       _FloatToStr+0
;uv2_click_example.c,104 :: 		Uart1_Write_Text(txt);
	MOVW       R16, R28
	SUBI       R16, 250
	SBCI       R17, 255
	MOVW       R2, R16
	CALL       _UART1_Write_Text+0
;uv2_click_example.c,105 :: 		Uart1_Write_Text("\r\n");
	LDI        R27, #lo_addr(?lstr2_uv2_click_example+0)
	MOV        R2, R27
	LDI        R27, hi_addr(?lstr2_uv2_click_example+0)
	MOV        R3, R27
	CALL       _UART1_Write_Text+0
;uv2_click_example.c,107 :: 		delay_ms(500);
	LDI        R18, 21
	LDI        R17, 75
	LDI        R16, 191
L_main4:
	DEC        R16
	BRNE       L_main4
	DEC        R17
	BRNE       L_main4
	DEC        R18
	BRNE       L_main4
	NOP
;uv2_click_example.c,108 :: 		}
	JMP        L_main2
;uv2_click_example.c,110 :: 		}
L_end_main:
	POP        R7
	POP        R6
	POP        R5
	POP        R4
	POP        R3
	POP        R2
L__main_end_loop:
	JMP        L__main_end_loop
; end of _main
